HDU 1052 Tian Ji -- The Horse Racing(贪心)(2004 Asia Regional Shanghai)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1052

Problem Description
Here is a famous story in Chinese history.

"That was about 2300 years ago. General Tian Ji was a high official in the country Qi. He likes to play horse racing with the king and others."

"Both of Tian and the king have three horses in different classes, namely, regular, plus, and super. The rule is to have three rounds in a match; each of the horses must be used in one round. The winner of a single round takes two hundred silver dollars from the loser."

"Being the most powerful man in the country, the king has so nice horses that in each class his horse is better than Tian's. As a result, each time the king takes six hundred silver dollars from Tian."

"Tian Ji was not happy about that, until he met Sun Bin, one of the most famous generals in Chinese history. Using a little trick due to Sun, Tian Ji brought home two hundred silver dollars and such a grace in the next match."

"It was a rather simple trick. Using his regular class horse race against the super class from the king, they will certainly lose that round. But then his plus beat the king's regular, and his super beat the king's plus. What a simple trick. And how do you think of Tian Ji, the high ranked official in China?"



Were Tian Ji lives in nowadays, he will certainly laugh at himself. Even more, were he sitting in the ACM contest right now, he may discover that the horse racing problem can be simply viewed as finding the maximum matching in a bipartite graph. Draw Tian's horses on one side, and the king's horses on the other. Whenever one of Tian's horses can beat one from the king, we draw an edge between them, meaning we wish to establish this pair. Then, the problem of winning as many rounds as possible is just to find the maximum matching in this graph. If there are ties, the problem becomes more complicated, he needs to assign weights 0, 1, or -1 to all the possible edges, and find a maximum weighted perfect matching...

However, the horse racing problem is a very special case of bipartite matching. The graph is decided by the speed of the horses --- a vertex of higher speed always beat a vertex of lower speed. In this case, the weighted bipartite matching algorithm is a too advanced tool to deal with the problem.

In this problem, you are asked to write a program to solve this special case of matching problem.
 
Input
The input consists of up to 50 test cases. Each case starts with a positive integer n (n <= 1000) on the first line, which is the number of horses on each side. The next n integers on the second line are the speeds of Tian’s horses. Then the next n integers on the third line are the speeds of the king’s horses. The input ends with a line that has a single 0 after the last test case.
 
Output
For each input case, output a line containing a single number, which is the maximum money Tian Ji will get, in silver dollars.
 
题目大意:中国古代的历史故事“田忌赛马”是为大家所熟知的。话说齐王和田忌又要赛马了,他们各派出N匹马(N≤2000),每场比赛,输的一方将要给赢的一方200两黄金,如果是平局的话,双方都不必拿出钱。现在每匹马的速度值是固定而且已知的,而齐王出马也不管田忌的出马顺序。请问田忌该如何安排自己的马去对抗齐王的马,才能赢最多的钱?(摘自IOI国家集训队论文 黄劲松:《贪婪的动态规划》)
思路:传说这是一条经典题。不过看大家的方法挺复杂的(主要是证明部分……),所以我也写一下我的方法。
首先,设田忌为A,齐王为B。不妨把他们的马按速度从大到小排序。
然后用4个指针,分别指向A、B的速度最大未用马、速度最小未用马。然后扫描。
情况1:max{A} < max{B},那么反正A最好的马肯定要赢,就去赢B最好的马,这个贪心的选择能为A剩下的马留出更多的胜算。
情况2:min{A} < min{B],那么反正B最差的马肯定要输,就用A最差的马来赢,显然用更好的马来赢是不划算的。
情况3:在情况1和情况2都没有的时候,即max{A} ≤ max{B},min{A} ≤ min{B}。那么就用A最差的马去和B最好的马竞技。
证明3:若min{A} < min{B},反正A也要输,不如输给B最好的马,显然是正确的贪心;若min{A} = min{B},若此时用A最差的马和B最差的马竞技,平手。我们可以用A最差的马,跟A前面的其中一只马交换对手,结果一定不会比前者差。所以这个贪心也显然是对的。
虽然写起来有点长但是思考起来还是蛮简单的嗯嗯。
 
代码(31MS):
 1 #include <cstdio>
 2 #include <cstring>
 3 #include <algorithm>
 4 #include <iostream>
 5 #include <functional>
 6 using namespace std;
 7 
 8 const int MAXN = 1010;
 9 
10 int a[MAXN], b[MAXN];
11 int n;
12 
13 int main() {
14     while(scanf("%d", &n) != EOF) {
15         if(n == 0) break;
16         for(int i = 0; i < n; ++i) scanf("%d", &a[i]);
17         for(int i = 0; i < n; ++i) scanf("%d", &b[i]);
18         sort(a, a + n, greater<int>());
19         sort(b, b + n, greater<int>());
20 
21         int la = 0, ra = n - 1, lb = 0, rb = n - 1, res = 0;
22         while(la <= ra) {
23             while(la <= ra && a[la] > b[lb]) ++res, ++la, ++lb;
24             while(la <= ra && a[ra] > b[rb]) ++res, --ra, --rb;
25             if(la <= ra) res -= (a[ra] < b[lb]), --ra, ++lb;
26         }
27         printf("%d\n", 200 * res);
28     }
29 }
View Code

 

posted @ 2014-08-17 11:48  Oyking  阅读(341)  评论(0编辑  收藏  举报